jQuery(function($) {

    //! Configuration for time pickers
    $('#slider_from').datetimepicker({
        showSecond: true,
        dateFormat: 'yy-mm-dd',
        timeFormat: 'HH:mm:ss',
        showTimezone: false,
        timezone: 'CT',
        timezoneList: [
            { value: 'ET', label: 'Eastern'},
            { value: 'CT', label: 'Central' },
            { value: 'MT', label: 'Mountain' },
            { value: 'PT', label: 'Pacific' }
        ]
    });
    $('#slider_to').datetimepicker({
        showSecond: true,
        dateFormat: 'yy-mm-dd',
        timeFormat: 'HH:mm:ss',
        //timeSuffix: 'Z',
        showTimezone: false,
        timezone: 'CT',
        timezoneList: [
            { value: 'ET', label: 'Eastern'},
            { value: 'CT', label: 'Central' },
            { value: 'MT', label: 'Mountain' },
            { value: 'PT', label: 'Pacific' }
        ]
    });

    //! Hide designated page elements and provide switch to display the details
    $(".hide-toggle").each(function() {
        var id = $(this).attr('id');
        //alert($(this).attr('id')+':'+$(this).text());
        if ($(this).hasClass('show')) {
            $(this).before("<a class=\"hide hide-toggle-switch\" href=\"#"+id+"\"><i class=\"icon-minus-squared\"></i>Hide details</a>");
        }
        else {
            $(this).before("<a class=\"show hide-toggle-switch\" href=\"#"+id+"\"><i class=\"icon-plus-squared\"></i>Show details</a>");
            $(this).hide();
        }
    });
    //! Logic behing the hide-toggle switch
    $(".hide-toggle-switch").live("click", function(e){
        //! Determine the target to be shown/hiddent
        var t = $(this).attr('href');
        t = t.replace(/^#/,'');
        //! Toggle the class of the link
        $(this).toggleClass("show hide");
        //alert('Toggle: '+$(this).attr('class')+', target: '+t);
        //! Make a decission based on the next state
        if ($(this).hasClass('show')) {
            $(this).html("<i class=\"icon-plus-squared\"></i>Show details</a>");
            $('#'+t).hide();
        }
        else {
            $(this).html("<i class=\"icon-minus-squared\"></i>Hide details");
            $('#'+t).show();
        }
        //! Prevent the anchor's default click action
        e.preventDefault();
    });

    //! Fading out flash messages
    //$('.flash-message').delay(10000).fadeOut(200, function(){
    //  $(this).remove();
    //});
    //! Closing flash messages on click
    //$('.flash-message').click(function(){
    //  $(this).remove();
    //});

    //! Tab groups - menu item toggle
    $(".toggle-tab-group").live("click", function(e){
        //! Hide everything
        $('.tab-group').hide();
        //! Get the id of desired chart group
        var te = e.target;
        if (!($(te).is('a'))) {
            te = $(te).closest('a');
        }
        var t = $(te).attr('href');
        t = t.replace(/^#/,'');
        //! Display the chart group
        $('#'+t).show();
        //! Display the first chart
        $('#'+t+' > .tab-item').first().show();
        //! Prevent the anchor's default click action
        e.preventDefault();
    });
    //! Tab groups - sub menu item toggle
    $(".toggle-tab").live("click", function(e){
        //! Hide everything
        $('.tab-item').hide();
        //! Get the id of desired chart
        var te = e.target;
        if (!($(te).is('a'))) {
            te = $(te).closest('a');
        }
        var t = $(te).attr('href');
        t = t.replace(/^#/,'');
        //! Display the tab
        $('#'+t).show();
        //! Prevent the anchor's default click action
        e.preventDefault();
    });
    //! Hide all visible tab groups
    $('.tab-group').hide();
    //! Hide all visible tabs
    $('.tab-item').hide();
    //! Display the first tab group
    $('.tab-group').first().show();
    //! Display the first tab
    $('.tab-item').first().show();


    //! Make JQueryUI accordion from anything with appropriate class
    $( ".accordion" ).accordion({
        heightStyle: "content",
        collapsible: true
    });

    //! Make some objects draggable using JQueryUI
    $( ".draggable" ).draggable({handle: ".move-handle", cursor: "move"});

    //! Make some objects resizable using JQueryUI
    $( ".resizable" ).resizable();

    //! Make the whole row in report list active
    //!$('tr[id^="report_"]').live('click',function(e){
    //! var id = $(this).attr('id');
    //! id = id.replace(/^report_/,'');
    //! document.location.href = "[% c.uri_for('/report/view/') %]"+id;
    //! //!window.open("[% c.uri_for('/report/view/') %]"+id);
    //!});

    //! Developer toolbar - menu item toggle
    $(".toggle-dt").live("click", function(e){
        //! Hide everything
        $('.dt-section').hide();
        //! Get the id of desired section
        var t = $(this).attr('href');
        t = t.replace(/^#/,'');
        //! Display the section
        $('#'+t).show();
        //! Prevent the anchor's default click action
        e.preventDefault();
    });
    //! Hide all visible developer toolbar sections
    $('.dt-section').hide();
    //! Display the first section
    $('.dt-section').first().show();

    //$('<li>All</li>').hide().prependTo('#dashboard-menu').slideDown("slow");

    $('#slider_date').datepicker({
        dateFormat: 'yy-mm-dd',
    });

    //! Vizualization of currently selected filter type (simple, advanced)
    $('#frm-flt-types').change(function(e){
        //!val = this.value
        //!alert('Simple: ' + val)
        $('.filter-simple').addClass('active');
        $('.filter-advanced').removeClass('active')
    });
    $('#frm-flt-typea').change(function(e){
        //!val = this.value
        //!alert('Advanced: ' + val)
        $('.filter-simple').removeClass('active');
        $('.filter-advanced').addClass('active')
    });

    //! Vizualization of currently selected report timing (default, custom)
    $('#frm-grp-rttype-c').change(function(e){
        //!val = this.value
        //!alert('Simple: ' + val)
        $('.timing-custom').addClass('active');
        $('.timing-default').removeClass('active')
    });
    $('#frm-grp-rttype-d').change(function(e){
        //!val = this.value
        //!alert('Advanced: ' + val)
        $('.timing-custom').removeClass('active');
        $('.timing-default').addClass('active')
    });

});
